﻿// If `notational` is true, it means NaN and infinite values are not allowed, otherwise, means they are allowed.
var binaryParserModule = function Binary(notational) {
		return function parseBinary(decimalInteger) {
				var inputString;
				if(typeof decimalInteger === "number")
				{
					if(decimalInteger === 0) inputString = (1 / decimalInteger === Infinity ? '+' : '-');
					else
						inputString = "";

					inputString += String(decimalInteger);
				}
				if(typeof decimalInteger === "string")
				{
					inputString = decimalInteger.trim();
				}

				if(inputString !== undefined)
				{
					if(!notational)
					{
						if(/^[+\-]?NaN$/.test(inputString)) return NaN;
						if(/^\+?Infinity$/.test(inputString)) return +Infinity;
						if(inputString === "-Infinity") return -Infinity;
					}
					if(!(/^[+\-]?[01]+$/.test(inputString))) throw new Error("Invalid argument!");

					var result = parseInt(inputString, 2);
					if(isNaN(result)) throw new Error("Invalid argument!")
					return result;
				}
				else
					throw new Error("Invalid argument!");
			};
	};

if(typeof exports === "undefined") this["Binary"] = binaryParserModule;
else
	module.exports = binaryParserModule;